<?php
/**
 * @version		1.0.0 amblog $
 * @package		amblog
 * @copyright	Copyright © 2010 - All rights reserved.
 * @license		GNU/GPL
 * @author		Tibor Fogler
 * @author mail	tibor.fogler@gmail.com
 * @website		http://adatmagus.hu
 *
 * @MVC architecture generated by MVC generator tool at http://www.alphaplug.com
 * 
 * tasks: browse,article,newForm,editForm,editSave,newSave,delete,
 *        addCommentForm,editCommentForm,savenewComment,saveEditComment
 * Request vars: catid,articleid,limitstart,limit,commentid,showComments,
 *               formId,form_fields
 * Used css classes: amblog_list, amblog_readmore, 
 *                   amblog_item, amblog_info,
 *                   amblog_article, amblog_comments,  
 *                   amblog_articleForm, amblog_articleFormHeader                              
 *                   amblog_commentForm, amblog_commentFormHeader
 * Ha catid=='?' akkor a $session->get('workspace') alapján keresi meg a
 * kataegoriát - és szükség esetén étre is hozza azt.                                                  
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class amblogController extends JController {
	function __construct()	{
		parent::__construct();
	}
  function browse() {
    $session = JFactory::getSession();
    $workspace = $session->get('workspace','1');
    $params = & JComponentHelper::getParams('com_amblog');
    $catid = $params->get('categoryid');
    $catid = JRequest::getVar('catid',$catid);
    if ($catid == '?') {
      // ebben az esetben a sessionban lévő projekt workspace alapján
      // kell megkeresni a kategoriát, ha még nincs létre kell hozni.
      $db = Jfactory::getDBO();
      $db->setQuery('
      select id 
      from #__categories
      where alias = "proj_'.$workspace.'"
      ');
      $res = $db->loadObjectList();
      if (count($res)>0) {
        $catid = $res[0]->id;
        $result = true;
      } else {
        $db->setQuery('
        insert into #__categories
      	(`parent_id`, 
      	`title`, 
      	`name`, 
      	`alias`, 
      	`image`, 
      	`section`, 
      	`image_position`, 
      	`description`, 
      	`published`, 
      	`checked_out`, 
      	`checked_out_time`, 
      	`editor`, 
      	`ordering`, 
      	`access`, 
      	`count`, 
      	`params`
      	)
        select 0,title,"","proj_'.$workspace.'","",7,"left",
            "'.$workspace.' project workspace",1,0,"0000-00-00",0,0,0,0,""
        from #__pf_projects
        where id='.$workspace);
        $db->query();
        $db->setQuery('
        select id 
        from #__categories
        where alias = "proj_'.$workspace.'"
        ');
        $res = $db->loadObjectList();
        if (count($res)>0) 
            $catid = $res[0]->id;
      }
      JRequest::setVar('catid',$catid);
    }
    $viewer = & $this->getView('amblog','html');
    $viewer->catid = $catid;
    $viewer->model = & $this->getModel();
    $viewer->user = & JFactory::getUser();
    $viewer->limitstart = JRequest::getVar('limitstart','0');
    $viewer->limit = JRequest::getVar('limit','10');
    $viewer->model->loadRecords($viewer->catid,$viewer->limitstart,$viewer->limit);
    $viewer->displayBrowser('','');
  }
  function article() {
    $params = &JComponentHelper::getParams('com_amblog');
    $viewer = & $this->getView('amblog','html');
    $viewer->model = & $this->getModel();
    $viewer->catid = $params->get('categoryid','0');
    $viewer->catid = JRequest::getVar('catid',$viewer->catid);
    $viewer->limitstart = JRequest::getVar('limitstart','0');
    $viewer->limit = JRequest::getVar('limit','10');
    $viewer->articleid = JRequest::getvar('articleid','0');
    $viewer->showComments = JRequest::getVar('showcomments','N');
    if ($viewer->model->load($viewer->articleid))
      $viewer->displayArticle('','');
    else {
      $viewer->model->loadRecords($viewer->catid,$viewer->limitstart,$viewer->limit);
      $viewer->displayBrowser(JText::_('article not found'),'ERROR');
    }                           
  }
  function newForm() {
    $viewer = & $this->getView('amblog','html');
    $params = &JComponentHelper::getParams('com_amblog');
    $viewer->model = & $this->getModel();
    $viewer->catid = $params->get('categoryid','0');
    $viewer->catid = JRequest::getVar('catid',$viewer->catid);
    $viewer->limitstart = JRequest::getVar('limitstart','0');
    $viewer->limit = JRequest::getVar('limit','10');
    $viewer->articleid = JRequest::getvar('articleid','0');
    $viewer->model->init($viewer->catid);
    $viewer->displayNewForm('','');
  }
  function editForm() {
    $viewer = & $this->getView('amblog','html');
    $params = &JComponentHelper::getParams('com_amblog');
    $viewer->model = & $this->getModel();
    $viewer->catid = $params->get('categoryid','0');
    $viewer->catid = JRequest::getVar('catid',$viewer->catid);
    $viewer->limitstart = JRequest::getVar('limitstart','0');
    $viewer->limit = JRequest::getVar('limit','10');
    $viewer->articleid = JRequest::getvar('articleid','0');
    if ($viewer->model->load($viewer->articleid))
      $viewer->displayEditForm('','');
    else {
      $viewer->model->loadRecords($viewer->catid,$viewer->limitstart,$viewer->limit);
      $viewer->displayBrowser(JText::_('article not found'),'ERROR');
    }                           
  }
  function editSave() {
    $session = JFactory::getSession();
    $params = &JComponentHelper::getParams('com_amblog');
    $viewer = & $this->getView('amblog','html');
    $viewer->model = & $this->getModel();
    $viewer->catid = $params->get('categoryid','0');
    $viewer->catid = JRequest::getVar('catid',$viewer->catid);
    $viewer->limitstart = JRequest::getVar('limitstart','0');
    $viewer->limit = JRequest::getVar('limit','10');
    $viewer->articleid = JRequest::getVar('articleid','0');
    $savedForms = $session->get('savedForms','start,');
    $formId = JRequest::getVar('formid',0);
    $viewer->model->load($viewer->articleid);
    $viewer->model->bind($_POST);
    if (strpos($savedForms,$formId.',')) {
        //$viewer->displayMsg('Feltehetőleg a böngésző Back gombját használta','warning');
        $this->browse();
        return true;
    }
    $session->set('savedForms',$savedForms.$formId.',');
    if ($viewer->model->check('edit')) {
      if ($viewer->model->store()) 
        $this->browse();
      else
        $viewer->displayEditForm(JText::_($viewer->model->errorMsg),'ERROR');
    } else {
        $viewer->displayEditForm(JText::_($viewer->model->errorMsg),'ERROR');
    }                         
  }
  function newSave() {
    $session = JFactory::getSession();
    $params = &JComponentHelper::getParams('com_amblog');
    $viewer = & $this->getView('amblog','html');
    $viewer->model = & $this->getModel();
    $viewer->catid = $params->get('categoryid','0');
    $viewer->catid = JRequest::getVar('catid',$viewer->catid);
    $viewer->limitstart = JRequest::getVar('limitstart','0');
    $viewer->limit = JRequest::getVar('limit','10');
    $viewer->articleid = JRequest::getVar('articleid','0');
    $savedForms = $session->get('savedForms','start,');
    $formId = JRequest::getVar('formid',0);
    $viewer->model->init($viewer->catid);
    $viewer->model->bind($_POST);
    if (strpos($savedForms,$formId.',')) {
        $viewer->displayMsg('Feltehetőleg a böngésző Back gombját használta','warning');
        $this->browse();
        return true;
    }
    $session->set('savedForms',$savedForms.$formId.',');
    if ($viewer->model->check('insert')) {
      if ($viewer->model->store()) {
        $this->browse();
      } else {
        $viewer->displayNewForm(JText::_($viewer->model->errorMsg),'ERROR');
      }                         
    } else {
        $viewer->displayNewForm(JText::_($viewer->model->errorMsg),'ERROR');
    }                           
  }
  function delete() {
    $params = &JComponentHelper::getParams('com_amblog');
    $viewer = & $this->getView('amblog','html');
    $viewer->model = & $this->getModel();
    $viewer->catid = $params->get('categoryid','0');
    $viewer->catid = JRequest::getVar('catid',$viewer->catid);
    $viewer->limitstart = JRequest::getVar('limitstart','0');
    $viewer->limit = JRequest::getVar('limit','10');
    $viewer->articleid = JRequest::getvar('articleid','0');
    $viewer->model->load($viewer->articleid);
    if ($viewer->model->canDelete()) {
      if ($viewer->model->remove()) 
        $this->browse();
      else {
        $errorMsg = $viewer->model->errorMsg;
        $viewer->model->loadRecords($viewer->catid,$viewer->limitstart,$viewer->limit);
        $viewer->displayBrowser(JText::_($errorMsg),'ERROR');
      }
    } else {
      $viewer->model->loadRecords($viewer->catid,$viewer->limitstart,$viewer->limit);
      $viewer->displayBrowser(JText::_('can not delete this article'),'ERROR');
    }  
  }
  function addCommentForm() {
    $params = &JComponentHelper::getParams('com_amblog');
    $viewer = & $this->getView('amblog','html');
    $viewer->model = & $this->getModel();
    $viewer->catid = $params->get('categoryid','0');
    $viewer->catid = JRequest::getVar('catid',$viewer-catid);
    $viewer->limitstart = JRequest::getVar('limitstart','0');
    $viewer->limit = JRequest::getVar('limit','10');
    $viewer->articleid = JRequest::getvar('articleid','0');
    $viewer->model->initComment($viewer-catid,$viewer-articleid);
    $viewer->displayNewCommentForm('','');
  }
  function editCommentForm() {
    $params = &JComponentHelper::getParams('com_amblog');
    $viewer = & $this->getView('amblog','html');
    $viewer->model = & $this->getModel();
    $viewer->catid = $params->get('categoryid','0');
    $viewer->catid = JRequest::getVar('catid',$viewer->catid);
    $viewer->limitstart = JRequest::getVar('limitstart','0');
    $viewer->limit = JRequest::getVar('limit','10');
    $viewer->articleid = JRequest::getVar('articleid','0');
    $viewer->commentid = JRequest::getVar('commentid','0');
    $viewer->model->load($viewer->articleid);
    $viewer->displayEditCommentForm('','');
  }
  function saveNewComment() {
    $user = JFactory::getUser();
    $session = JFactory::getSession();
    $params = &JComponentHelper::getParams('com_amblog');
    $viewer = & $this->getView('amblog','html');
    $viewer->model = & $this->getModel();
    $viewer->catid = $params->get('categoryid','0');
    $viewer->catid = JRequest::getVar('catid',$viewer->catid);
    $viewer->limitstart = JRequest::getVar('limitstart','0');
    $viewer->limit = JRequest::getVar('limit','10');
    $viewer->articleid = JRequest::getVar('articleid',0);
    $savedForms = $session->get('savedForms','start,');
    $formId = JRequest::getVar('formid',0);
    $viewer->commentid = 0;
    $viewer->model->load($viewer->articleid);
    $viewer->model->bindComment($_POST,0);
    $viewer->model->comments[0]['id']=0;
    if (strpos($savedForms,$formId.',')) {
        //$viewer->displayMsg('Feltehetőleg a böngésző Back gombját használta','warning');
        $this->article();
        return true;
    }
    $session->set('savedForms',$savedForms.$formId.',');
    if ($viewer->model->checkComment('insert',0)) {
      if ($viewer->model->storeComment(0)) 
        $this->article();
      else
        $viewer->displayNewCommentForm(JText::_($viewer->model->errorMsg),'ERROR');
    } else {
      $viewer->displayNewCommentForm(JText::_($viewer->model->errorMsg),'ERROR');
    }                         
  }
  function saveEditComment() {
    $session = JFactory::getSession();
    $params = &JComponentHelper::getParams('com_amblog');
    $viewer = & $this->getView('amblog','html');
    $viewer->model = & $this->getModel();
    $viewer->catid = $params->get('categoryid','0');
    $viewer->catid = JRequest::getVar('catid',$viewer->catid);
    $viewer->limitstart = JRequest::getVar('limitstart','0');
    $viewer->limit = JRequest::getVar('limit','10');
    $viewer->articleid = JRequest::getVar('articleid','0');
    $viewer->commentid = JRequest::getVar('commentid','0');
    $savedForms = $session->get('savedForms','start,');
    $formId = JRequest::getVar('formid',0);
    $viewer->model->load($viewer->articleid);
    $viewer->model->bindComment($_POST,$viewer->commentid);
    if (strpos($savedForms,$formId.',')) {
        //$viewer->displayMsg('Feltehetőleg a böngésző Back gombját használta','warning');
        $this->article();
        return true;
    }
    $session->set('savedForms',$savedForms.$formId.',');
    if ($viewer->model->checkComment('edit',$viewer->commentid)) {
      if ($viewer->model->storeComment($viewer->commentid)) 
        $this->article();
      else
        $viewer->displayEditCommentForm(JText::_($viewer->model->errorMsg),'ERROR');
    } else {
      $viewer->displayEditCommentForm(JText::_($viewer->model->errorMsg),'ERROR');
    }                         
  }
}
?>